import { system } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../utils";
import * as menuUI from "./ui";
import * as attributesUI from "./ui";

//@kaioken
export function kaioken(player) {
  const form = new ActionFormData();
  form.title("ui.menu.title");
  form.button("ui.menu.button_1");
  form.button("ui.menu.button_2");
  form.button("kaioken");
  form.button("entity.dbe:shadow_dummy.name");
  system.run(() =>
    form.show(player).then((response) => {
      switch (response.selection) {
        case 0:
          attributesUI.attributes(player);
          break;
        case 1:
          if (
            getScore(player, "dbe:mission") == 12 &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            missionsUI.endSaga(player);
          } else if (!player.hasTag("dbe:safe_zone_gamemode")) {
            missionsUI[`mission_${getScore(player, "dbe:mission")}`](player);
          } else
            system.runTimeout(() => {
              player.sendMessage({ rawtext: [{ translate: "warn.error.3" }] });
            }, 1);
          break;
        case 2:
          kaioken_x3(player);
          player.triggerEvent("dbe:kaioken");
          break;
        case 3:
          if (
            !player.hasTag("dbe:shadow_dummy") &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            player.triggerEvent("dbe:shadow_dummy");
          } else
            player.sendMessage({ rawtext: [{ translate: "warn.error.2" }] });
          break;
      }
    })
  );
}
//@kaioken x3
export function kaioken_x3(player) {
  const form = new ActionFormData();
  form.title("ui.menu.title");
  form.button("ui.menu.button_1");
  form.button("ui.menu.button_2");
  form.button("kaioken_x3");
  form.button("entity.dbe:shadow_dummy.name");
  system.run(() =>
    form.show(player).then((response) => {
      switch (response.selection) {
        case 0:
          attributesUI.attributes(player);
          break;
        case 1:
          if (
            getScore(player, "dbe:mission") == 12 &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            missionsUI.endSaga(player);
          } else if (!player.hasTag("dbe:safe_zone_gamemode")) {
            missionsUI[`mission_${getScore(player, "dbe:mission")}`](player);
          } else
            system.runTimeout(() => {
              player.sendMessage({ rawtext: [{ translate: "warn.error.3" }] });
            }, 1);
          break;
        case 2:
          kaioken_x10(player);
          player.triggerEvent("dbe:kaioken");
          break;
        case 3:
          if (
            !player.hasTag("dbe:shadow_dummy") &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            player.triggerEvent("dbe:shadow_dummy");
          } else
            player.sendMessage({ rawtext: [{ translate: "warn.error.2" }] });
          break;
      }
    })
  );
}
//@kaioken x10
export function kaioken_x10(player) {
  const form = new ActionFormData();
  form.title("ui.menu.title");
  form.button("ui.menu.button_1");
  form.button("ui.menu.button_2");
  form.button("kaioken_x10");
  form.button("entity.dbe:shadow_dummy.name");
  system.run(() =>
    form.show(player).then((response) => {
      switch (response.selection) {
        case 0:
          attributesUI.attributes(player);
          break;
        case 1:
          if (
            getScore(player, "dbe:mission") == 12 &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            missionsUI.endSaga(player);
          } else if (!player.hasTag("dbe:safe_zone_gamemode")) {
            missionsUI[`mission_${getScore(player, "dbe:mission")}`](player);
          } else
            system.runTimeout(() => {
              player.sendMessage({ rawtext: [{ translate: "warn.error.3" }] });
            }, 1);
          break;
        case 2:
          kaioken_x20(player);
          player.triggerEvent("dbe:kaioken");
          break;
        case 3:
          if (
            !player.hasTag("dbe:shadow_dummy") &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            player.triggerEvent("dbe:shadow_dummy");
          } else
            player.sendMessage({ rawtext: [{ translate: "warn.error.2" }] });
          break;
      }
    })
  );
}
//@kaioken x20
export function kaioken_x20(player) {
  const form = new ActionFormData();
  form.title("ui.menu.title");
  form.button("ui.menu.button_1");
  form.button("ui.menu.button_2");
  form.button("kaioken_x20");
  form.button("entity.dbe:shadow_dummy.name");
  system.run(() =>
    form.show(player).then((response) => {
      switch (response.selection) {
        case 0:
          attributesUI.attributes(player);
          break;
        case 1:
          if (
            getScore(player, "dbe:mission") == 12 &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            missionsUI.endSaga(player);
          } else if (!player.hasTag("dbe:safe_zone_gamemode")) {
            missionsUI[`mission_${getScore(player, "dbe:mission")}`](player);
          } else
            system.runTimeout(() => {
              player.sendMessage({ rawtext: [{ translate: "warn.error.3" }] });
            }, 1);
          break;
        case 2:
          menuUI.menu(player);
          player.removeTag("dbe:has_kaioken");
          player.triggerEvent("dbe:kaioken_false");
          player.triggerEvent("dbe:kaioken");
          break;
        case 3:
          if (
            !player.hasTag("dbe:shadow_dummy") &&
            !player.hasTag("dbe:safe_zone_gamemode")
          ) {
            player.triggerEvent("dbe:shadow_dummy");
          } else
            player.sendMessage({ rawtext: [{ translate: "warn.error.2" }] });
          break;
      }
    })
  );
}
