import { system } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../utils";
import * as menuUI from "./ui";
import * as kaiokenUI from "./kaioken";

function createMissionForm(
  player,
  titleKey,
  textKey,
  objectiveKey,
  missionFunction,
  missionNumber
) {
  const form = new ActionFormData();
  form.title("ui.missions.title");
  form.button("");
  form.button("mission.start");
  form.body(`%${titleKey}\n\n%${textKey}\n\n%${objectiveKey}`);
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        handleMissionSelection(player);
        break;
      case 1:
        handleMissionStart(player, missionFunction, missionNumber);
        break;
    }
  });
}

function handleMissionSelection(player) {
  if (player.hasTag("dbe:kaioken")) {
    kaiokenUI.kaioken(player);
  } else if (player.hasTag("dbe:kaioken_x3")) {
    kaiokenUI.kaioken_x3(player);
  } else if (player.hasTag("dbe:kaioken_x10")) {
    kaiokenUI.kaioken_x10(player);
  } else if (player.hasTag("dbe:kaioken_x20")) {
    kaiokenUI.kaioken_x20(player);
  } else {
    system.runTimeout(() => {
      menuUI.menu(player);
    }, 1);
  }
}

function handleMissionStart(player, missionFunction, missionNumber) {
  const missionScore = getScore(player, `dbe:mission2`);
  const missionTimer = getScore(player, `dbe:mission3`);
  if (missionScore > 0 && missionTimer > 0) {
    player.sendMessage({
      rawtext: [
        {
          translate: "mission.error.1",
          with: {
            rawtext: [{ score: { name: "*", objective: "dbe:mission3" } }],
          },
        },
      ],
    });
  } else if ((missionTimer == 0 && missionScore == 1) || missionScore == 3) {
    player.sendMessage({
      rawtext: [
        {
          translate: "mission.error.2",
        },
      ],
    });
  } else {
    runMissionCommand(player, missionFunction, missionNumber);
  }
}

function runMissionCommand(player, missionFunction, missionNumber) {
  switch (missionNumber) {
    case 1:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 2:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 3:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 4:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 5:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 6:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 7:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 8:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 9:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 10:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 11:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 12:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 13:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 14:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 15:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 16:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 17:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 18:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 19:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 20:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 21:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;
    case 22:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;     
    case 23:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;  
    case 24:
      player.runCommandAsync(`function sagas/classic/mission_${missionNumber}`);
      break;  
    case 25:
      player.runCommandAsync(`function sagas/castle/mission_${missionNumber}`);
      break;  
    case 26:
      player.runCommandAsync(`function sagas/castle/mission_${missionNumber}`);
      break;  
    case 27:
      player.runCommandAsync(`function sagas/castle/mission_${missionNumber}`);
      break; 
    case 28:
      player.runCommandAsync(`function sagas/garlic/mission_${missionNumber}`);
      break;  
    case 29:
      player.runCommandAsync(`function sagas/garlic/mission_${missionNumber}`);
      break;  
    case 30:
      player.runCommandAsync(`function sagas/garlic/mission_${missionNumber}`);
      break;  
    case 31:
      player.runCommandAsync(`function sagas/garlic/mission_${missionNumber}`);
      break;  
    case 32:
      player.runCommandAsync(`function sagas/strong/mission_${missionNumber}`);
      break;  
    case 33:
      player.runCommandAsync(`function sagas/strong/mission_${missionNumber}`);
      break;  
    case 34:
      player.runCommandAsync(`function sagas/strong/mission_${missionNumber}`);
      break;  
    case 35:
      player.runCommandAsync(`function sagas/strong/mission_${missionNumber}`);
      break;  
    case 36:
      player.runCommandAsync(`function sagas/strong/mission_${missionNumber}`);
      break;
    case 37:
      player.runCommandAsync(`function sagas/saiyan/mission_${missionNumber}`);
      break;  
    case 38:
      player.runCommandAsync(`function sagas/turles/mission_${missionNumber}`);
      break;  
    case 39:
      player.runCommandAsync(`function sagas/turles/mission_${missionNumber}`);
      break; 
    case 40:
      player.runCommandAsync(`function sagas/turles/mission_${missionNumber}`);
      break;  
    case 41:
      player.runCommandAsync(`function sagas/turles/mission_${missionNumber}`);
      break;  
    case 42:
      player.runCommandAsync(`function sagas/turles/mission_${missionNumber}`);
      break;  
    case 43:
      player.runCommandAsync(`function sagas/turles/mission_${missionNumber}`);
      break;  
    case 44:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 45:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 46:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 47:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 48:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 49:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 50:
      player.runCommandAsync(`function sagas/slug/mission_${missionNumber}`);
      break;  
    case 51:
      player.runCommandAsync(`function sagas/saiyan/mission_${missionNumber}`);
      break;  
    case 52:
      player.runCommandAsync(`function sagas/saiyan/mission_${missionNumber}`);
      break;  
    case 53:
      player.runCommandAsync(`function sagas/saiyan/mission_${missionNumber}`);
      break;  
    case 54:
      player.runCommandAsync(`function sagas/freeza/mission_${missionNumber}`);
      break;  
    case 55:
      player.runCommandAsync(`function sagas/freeza/mission_${missionNumber}`);
      break;  
    case 56:
      player.runCommandAsync(`function sagas/freeza/mission_${missionNumber}`);
      break;  
    case 57:
      player.runCommandAsync(`function sagas/freeza/mission_${missionNumber}`);
      break;  
    case 58:
      player.runCommandAsync(`function sagas/freeza/mission_${missionNumber}`);
      break;  
    case 59:
      player.runCommandAsync(`function sagas/freeza/mission_${missionNumber}`);
      break;  
    case 60:
      player.runCommandAsync(`function sagas/cooler/mission_${missionNumber}`);
      break;  
    case 61:
      player.runCommandAsync(`function sagas/cooler/mission_${missionNumber}`);
      break;  
    case 62:
      player.runCommandAsync(`function sagas/cooler/mission_${missionNumber}`);
      break;  
    case 63:
      player.runCommandAsync(`function sagas/cooler/mission_${missionNumber}`);
      break;  
    case 64:
      player.runCommandAsync(`function sagas/cooler/mission_${missionNumber}`);
      break;  
    case 65:
      player.runCommandAsync(`function sagas/cooler/mission_${missionNumber}`);
      break;  
    case 66:
      player.runCommandAsync(`function sagas/trunks/mission_${missionNumber}`);
      break;  
    case 67:
      player.runCommandAsync(`function sagas/trunks/mission_${missionNumber}`);
      break;  
    case 68:
      player.runCommandAsync(`function sagas/trunks/mission_${missionNumber}`);
      break;  
    case 69:
      player.runCommandAsync(`function sagas/metalcooler/mission_${missionNumber}`);
      break;  
    case 70:
      player.runCommandAsync(`function sagas/metalcooler/mission_${missionNumber}`);
      break;  
    case 71:
      player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
      break;        
    case 72:
      player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
      break;       
    case 73:
      player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
      break;  
    case 74:
      player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
      break;  
    case 75:
      player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
      break;  
    case 76:
       player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
       break;  
    case 77:
       player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
       break;  
    case 78:
      player.runCommandAsync(`function sagas/android/mission_${missionNumber}`);
      break;  
    case 79:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;        
    case 80:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;       
    case 81:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;    
    case 82:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;    
    case 83:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;       
    case 84:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;    
    case 85:
      player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
      break;    
      case 86:
        player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
        break;   
        case 87:
          player.runCommandAsync(`function sagas/broly/mission_${missionNumber}`);
          break;  
          case 88:
          player.runCommandAsync(`function sagas/bojack/mission_${missionNumber}`);
          break;   
          case 89:
          player.runCommandAsync(`function sagas/bojack/mission_${missionNumber}`);
          break;    
          case 90:
            player.runCommandAsync(`function sagas/bojack/mission_${missionNumber}`);
            break;   
            case 91:
            player.runCommandAsync(`function sagas/bojack/mission_${missionNumber}`);
            break;   
            case 92:
          player.runCommandAsync(`function sagas/bojack/mission_${missionNumber}`);
          break;                     
  }
}

export function mission_1(player) {
  createMissionForm(
    player,
    "mission.title_1",
    "mission.text_1",
    "mission.objective_1",
    "mission_1",
    1
  );
}

export function mission_2(player) {
  createMissionForm(
    player,
    "mission.title_2",
    "mission.text_2",
    "mission.objective_2",
    "mission_2",
    2
  );
}

export function mission_3(player) {
  createMissionForm(
    player,
    "mission.title_3",
    "mission.text_3",
    "mission.objective_3",
    "mission_3",
    3
  );
}

export function mission_4(player) {
  createMissionForm(
    player,
    "mission.title_4",
    "mission.text_4",
    "mission.objective_4",
    "mission_4",
    4
  );
}

export function mission_5(player) {
  createMissionForm(
    player,
    "mission.title_5",
    "mission.text_5",
    "mission.objective_5",
    "mission_5",
    5
  );
}

export function mission_6(player) {
  createMissionForm(
    player,
    "mission.title_6",
    "mission.text_6",
    "mission.objective_6",
    "mission_6",
    6
  );
}

export function mission_7(player) {
  createMissionForm(
    player,
    "mission.title_7",
    "mission.text_7",
    "mission.objective_7",
    "mission_7",
    7
  );
}

export function mission_8(player) {
  createMissionForm(
    player,
    "mission.title_8",
    "mission.text_8",
    "mission.objective_8",
    "mission_8",
    8
  );
}

export function mission_9(player) {
  createMissionForm(
    player,
    "mission.title_9",
    "mission.text_9",
    "mission.objective_9",
    "mission_9",
    9
  );
}

export function mission_10(player) {
  createMissionForm(
    player,
    "mission.title_10",
    "mission.text_10",
    "mission.objective_10",
    "mission_10",
    10
  );
}

export function mission_11(player) {
  createMissionForm(
    player,
    "mission.title_11",
    "mission.text_11",
    "mission.objective_11",
    "mission_11",
    11
  );
}


export function mission_12(player) {
  createMissionForm(
    player,
    "mission.title_12",
    "mission.text_12",
    "mission.objective_12",
    "mission_12",
    12
  );
}


export function mission_13(player) {
  createMissionForm(
    player,
    "mission.title_13",
    "mission.text_13",
    "mission.objective_13",
    "mission_13",
    13
  );
}

export function mission_14(player) {
  createMissionForm(
    player,
    "mission.title_14",
    "mission.text_14",
    "mission.objective_14",
    "mission_14",
    14
  );
}

export function mission_15(player) {
  createMissionForm(
    player,
    "mission.title_15",
    "mission.text_15",
    "mission.objective_15",
    "mission_15",
    15
  );
}

export function mission_16(player) {
  createMissionForm(
    player,
    "mission.title_16",
    "mission.text_16",
    "mission.objective_16",
    "mission_16",
    16
  );
}

export function mission_17(player) {
  createMissionForm(
    player,
    "mission.title_17",
    "mission.text_17",
    "mission.objective_17",
    "mission_17",
    17
  );
}

export function mission_18(player) {
  createMissionForm(
    player,
    "mission.title_18",
    "mission.text_18",
    "mission.objective_18",
    "mission_18",
    18
  );
}

export function mission_19(player) {
  createMissionForm(
    player,
    "mission.title_19",
    "mission.text_19",
    "mission.objective_19",
    "mission_19",
    19
  );
}

export function mission_20(player) {
  createMissionForm(
    player,
    "mission.title_20",
    "mission.text_20",
    "mission.objective_20",
    "mission_20",
    20
  );
}

export function mission_21(player) {
  createMissionForm(
    player,
    "mission.title_21",
    "mission.text_21",
    "mission.objective_21",
    "mission_21",
    21
  );
}

export function mission_22(player) {
  createMissionForm(
    player,
    "mission.title_22",
    "mission.text_22",
    "mission.objective_22",
    "mission_22",
    22
  );
}

export function mission_23(player) {
  createMissionForm(
    player,
    "mission.title_23",
    "mission.text_23",
    "mission.objective_23",
    "mission_23",
    23
  );
}

export function mission_24(player) {
  createMissionForm(
    player,
    "mission.title_24",
    "mission.text_24",
    "mission.objective_24",
    "mission_24",
    24
  );
}

export function mission_25(player) {
  createMissionForm(
    player,
    "mission.title_25",
    "mission.text_25",
    "mission.objective_25",
    "mission_25",
    25
  );
}
export function mission_26(player) {
  createMissionForm(
    player,
    "mission.title_26",
    "mission.text_26",
    "mission.objective_26",
    "mission_26",
    26
  );
}
export function mission_27(player) {
  createMissionForm(
    player,
    "mission.title_27",
    "mission.text_27",
    "mission.objective_27",
    "mission_27",
    27
  );
}
export function mission_28(player) {
  createMissionForm(
    player,
    "mission.title_28",
    "mission.text_28",
    "mission.objective_28",
    "mission_28",
    28
  );
}
export function mission_29(player) {
  createMissionForm(
    player,
    "mission.title_29",
    "mission.text_29",
    "mission.objective_29",
    "mission_29",
    29
  );
}
export function mission_30(player) {
  createMissionForm(
    player,
    "mission.title_30",
    "mission.text_30",
    "mission.objective_30",
    "mission_30",
    30
  );
}
export function mission_31(player) {
  createMissionForm(
    player,
    "mission.title_31",
    "mission.text_31",
    "mission.objective_31",
    "mission_31",
    31
  );
}
export function mission_32(player) {
  createMissionForm(
    player,
    "mission.title_32",
    "mission.text_32",
    "mission.objective_32",
    "mission_32",
    32
  );
}
export function mission_33(player) {
  createMissionForm(
    player,
    "mission.title_33",
    "mission.text_33",
    "mission.objective_33",
    "mission_33",
    33
  );
}
export function mission_34(player) {
  createMissionForm(
    player,
    "mission.title_34",
    "mission.text_34",
    "mission.objective_34",
    "mission_34",
    34
  );
}
export function mission_35(player) {
  createMissionForm(
    player,
    "mission.title_35",
    "mission.text_35",
    "mission.objective_35",
    "mission_35",
    35
  );
}
export function mission_36(player) {
  createMissionForm(
    player,
    "mission.title_36",
    "mission.text_36",
    "mission.objective_36",
    "mission_36",
    36
  );
}
export function mission_37(player) {
  createMissionForm(
    player,
    "mission.title_37",
    "mission.text_37",
    "mission.objective_37",
    "mission_37",
    37
  );
}
export function mission_38(player) {
  createMissionForm(
    player,
    "mission.title_38",
    "mission.text_38",
    "mission.objective_38",
    "mission_38",
    38
  );
}
export function mission_39(player) {
  createMissionForm(
    player,
    "mission.title_39",
    "mission.text_39",
    "mission.objective_39",
    "mission_39",
    39
  );
}
export function mission_40(player) {
  createMissionForm(
    player,
    "mission.title_40",
    "mission.text_40",
    "mission.objective_40",
    "mission_40",
    40
  );
}
export function mission_41(player) {
  createMissionForm(
    player,
    "mission.title_41",
    "mission.text_41",
    "mission.objective_41",
    "mission_41",
    41
  );
}
export function mission_42(player) {
  createMissionForm(
    player,
    "mission.title_42",
    "mission.text_42",
    "mission.objective_42",
    "mission_42",
    42
  );
}
export function mission_43(player) {
  createMissionForm(
    player,
    "mission.title_43",
    "mission.text_43",
    "mission.objective_43",
    "mission_43",
    43
  );
}
export function mission_44(player) {
  createMissionForm(
    player,
    "mission.title_44",
    "mission.text_44",
    "mission.objective_44",
    "mission_44",
    44
  );
}
export function mission_45(player) {
  createMissionForm(
    player,
    "mission.title_45",
    "mission.text_45",
    "mission.objective_45",
    "mission_45",
    45
  );
}
export function mission_46(player) {
  createMissionForm(
    player,
    "mission.title_46",
    "mission.text_46",
    "mission.objective_46",
    "mission_46",
    46
  );
}
export function mission_47(player) {
  createMissionForm(
    player,
    "mission.title_47",
    "mission.text_47",
    "mission.objective_47",
    "mission_47",
    47
  );
}
export function mission_48(player) {
  createMissionForm(
    player,
    "mission.title_48",
    "mission.text_48",
    "mission.objective_48",
    "mission_48",
    48
  );
}
export function mission_49(player) {
  createMissionForm(
    player,
    "mission.title_49",
    "mission.text_49",
    "mission.objective_49",
    "mission_49",
    49
  );
}
export function mission_50(player) {
  createMissionForm(
    player,
    "mission.title_50",
    "mission.text_50",
    "mission.objective_50",
    "mission_50",
    50
  );
}
export function mission_51(player) {
  createMissionForm(
    player,
    "mission.title_51",
    "mission.text_51",
    "mission.objective_51",
    "mission_51",
    51
  );
}
export function mission_52(player) {
  createMissionForm(
    player,
    "mission.title_52",
    "mission.text_52",
    "mission.objective_52",
    "mission_52",
    52
  );
}
export function mission_53(player) {
  createMissionForm(
    player,
    "mission.title_53",
    "mission.text_53",
    "mission.objective_53",
    "mission_53",
    53
  );
}
export function mission_54(player) {
  createMissionForm(
    player,
    "mission.title_54",
    "mission.text_54",
    "mission.objective_54",
    "mission_54",
    54
  );
}
export function mission_55(player) {
  createMissionForm(
    player,
    "mission.title_55",
    "mission.text_55",
    "mission.objective_55",
    "mission_55",
    55
  );
}
export function mission_56(player) {
  createMissionForm(
    player,
    "mission.title_56",
    "mission.text_56",
    "mission.objective_56",
    "mission_56",
    56
  );
}
export function mission_57(player) {
  createMissionForm(
    player,
    "mission.title_57",
    "mission.text_57",
    "mission.objective_57",
    "mission_57",
    57
  );
}
export function mission_58(player) {
  createMissionForm(
    player,
    "mission.title_58",
    "mission.text_58",
    "mission.objective_58",
    "mission_58",
    58
  );
}
export function mission_59(player) {
  createMissionForm(
    player,
    "mission.title_59",
    "mission.text_59",
    "mission.objective_59",
    "mission_59",
    59
  );
}
export function mission_60(player) {
  createMissionForm(
    player,
    "mission.title_60",
    "mission.text_60",
    "mission.objective_60",
    "mission_60",
    60
  );
}
export function mission_61(player) {
  createMissionForm(
    player,
    "mission.title_61",
    "mission.text_61",
    "mission.objective_61",
    "mission_61",
    61
  );
}
export function mission_62(player) {
  createMissionForm(
    player,
    "mission.title_62",
    "mission.text_62",
    "mission.objective_62",
    "mission_62",
    62
  );
}
export function mission_63(player) {
  createMissionForm(
    player,
    "mission.title_63",
    "mission.text_63",
    "mission.objective_63",
    "mission_63",
    63
  );
}
export function mission_64(player) {
  createMissionForm(
    player,
    "mission.title_64",
    "mission.text_64",
    "mission.objective_64",
    "mission_64",
    64
  );
}
export function mission_65(player) {
  createMissionForm(
    player,
    "mission.title_65",
    "mission.text_65",
    "mission.objective_65",
    "mission_65",
    65
  );
}
export function mission_66(player) {
  createMissionForm(
    player,
    "mission.title_66",
    "mission.text_66",
    "mission.objective_66",
    "mission_66",
    66
  );
}
export function mission_67(player) {
  createMissionForm(
    player,
    "mission.title_67",
    "mission.text_67",
    "mission.objective_67",
    "mission_67",
    67
  );
}
export function mission_68(player) {
  createMissionForm(
    player,
    "mission.title_68",
    "mission.text_68",
    "mission.objective_68",
    "mission_68",
    68
  );
}
export function mission_69(player) {
  createMissionForm(
    player,
    "mission.title_69",
    "mission.text_69",
    "mission.objective_69",
    "mission_69",
    69
  );
}
export function mission_70(player) {
  createMissionForm(
    player,
    "mission.title_70",
    "mission.text_70",
    "mission.objective_70",
    "mission_70",
    70
  );
}
export function mission_71(player) {
  createMissionForm(
    player,
    "mission.title_71",
    "mission.text_71",
    "mission.objective_71",
    "mission_71",
    71
  );
}
export function mission_72(player) {
  createMissionForm(
    player,
    "mission.title_72",
    "mission.text_72",
    "mission.objective_72",
    "mission_72",
    72
  );
}
export function mission_73(player) {
  createMissionForm(
    player,
    "mission.title_73",
    "mission.text_73",
    "mission.objective_73",
    "mission_73",
    73
  );
}
export function mission_74(player) {
  createMissionForm(
    player,
    "mission.title_74",
    "mission.text_74",
    "mission.objective_74",
    "mission_74",
    74
  );
}
export function mission_75(player) {
  createMissionForm(
    player,
    "mission.title_75",
    "mission.text_75",
    "mission.objective_75",
    "mission_75",
    75
  );
}
export function mission_76(player) {
  createMissionForm(
    player,
    "mission.title_76",
    "mission.text_76",
    "mission.objective_76",
    "mission_76",
    76
  );
}
export function mission_77(player) {
  createMissionForm(
    player,
    "mission.title_77",
    "mission.text_77",
    "mission.objective_77",
    "mission_77",
    77
  );
}
export function mission_78(player) {
  createMissionForm(
    player,
    "mission.title_78",
    "mission.text_78",
    "mission.objective_78",
    "mission_78",
    78
  );
}
export function mission_79(player) {
  createMissionForm(
    player,
    "mission.title_79",
    "mission.text_79",
    "mission.objective_79",
    "mission_79",
    79
  );
}
export function mission_80(player) {
  createMissionForm(
    player,
    "mission.title_80",
    "mission.text_80",
    "mission.objective_80",
    "mission_80",
    80
  );
}
export function mission_81(player) {
  createMissionForm(
    player,
    "mission.title_81",
    "mission.text_81",
    "mission.objective_81",
    "mission_81",
    81
  );
}
export function mission_82(player) {
  createMissionForm(
    player,
    "mission.title_82",
    "mission.text_82",
    "mission.objective_82",
    "mission_82",
    82
  );
}
export function mission_83(player) {
  createMissionForm(
    player,
    "mission.title_83",
    "mission.text_83",
    "mission.objective_83",
    "mission_83",
    83
  );
}
export function mission_84(player) {
  createMissionForm(
    player,
    "mission.title_84",
    "mission.text_84",
    "mission.objective_84",
    "mission_84",
    84
  );
}
export function mission_85(player) {
  createMissionForm(
    player,
    "mission.title_85",
    "mission.text_85",
    "mission.objective_85",
    "mission_85",
    85
  );
}
export function mission_86(player) {
  createMissionForm(
    player,
    "mission.title_86",
    "mission.text_86",
    "mission.objective_86",
    "mission_86",
    86
  );
}
export function mission_87(player) {
  createMissionForm(
    player,
    "mission.title_87",
    "mission.text_87",
    "mission.objective_87",
    "mission_87",
    87
  );
}
export function mission_88(player) {
  createMissionForm(
    player,
    "mission.title_88",
    "mission.text_88",
    "mission.objective_88",
    "mission_88",
    88
  );
}
export function mission_89(player) {
  createMissionForm(
    player,
    "mission.title_89",
    "mission.text_89",
    "mission.objective_89",
    "mission_89",
    89
  );
}
export function mission_90(player) {
  createMissionForm(
    player,
    "mission.title_90",
    "mission.text_90",
    "mission.objective_90",
    "mission_90",
    90
  );
}
export function mission_91(player) {
  createMissionForm(
    player,
    "mission.title_91",
    "mission.text_91",
    "mission.objective_91",
    "mission_91",
    91
  );
}
export function mission_92(player) {
  createMissionForm(
    player,
    "mission.title_92",
    "mission.text_92",
    "mission.objective_92",
    "mission_92",
    92
  );
}
export function endSaga(player) {
  const form = new ActionFormData();
  form.title("ui.end_saga.title");
  form.button("");
  form.body("%title.end_of_saga\n\n%text.end_of_saga");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        handleMissionSelection(player);
        break;
    }
  });
}
