//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:beerusnpc") system.runTimeout(() => beerusnpc(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:beerusnpc") system.runTimeout(() => beerusnpc(evd.damagingEntity))
})

//beerusnpc
function beerusnpc(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:beerusnpc.name");
  form.body("ui.beerusnpc.description");
  form.button(" ");
  form.button("ui.beerusnpc.button.1");
  form.button("ui.beerusnpc.button_2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        fist(player);
        break;
      case 2:
        god_ki(player);
        break;
      case 3:
        planet(player);
        break;        
    }
  });
}

//beerusnpc #fist
function fist(player) {
  const form = new ActionFormData();
  form.title("ui.beerusnpc.title");
  form.body("ui.fist.description");
  form.button("");
  form.button("learn_fist");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        beerusnpc(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 90000 &&
          !player.hasTag("dbe:has_fist")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 90000");
          player.runCommandAsync(
            'give @s dbe:god_blade 1 0 {"minecraft:keep_on_death":{}}'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:fist.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_fist")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 90000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
      }
    });
  }
  
//beerusnpc #divine ki
function god_ki(player) {
  const form = new ActionFormData();
  form.title("ui.beerusnpc.title");
  form.body("ui.god_ki.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        beerusnpc(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 80000 &&
          !player.hasTag("dbe:has_god_ki")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 80000");
          player.addTag("dbe:has_god_ki");
          player.sendMessage({ rawtext: [{ translate: "learn.god_ki" }] });
        } else if (player.hasTag("dbe:has_god_ki")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.3" }] });
        } else if (getScore(player, "dbe:tp") < 80000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}

//beerusnpc #planet
function planet(player) {
  const form = new ActionFormData();
  form.title("ui.beerusnpc.title");
  form.body("ui.planet.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        beerusnpc(player);
        break;
        case 1:
          player.teleport({ x: 5000, y:  150, z: 5000 }, { dimension: world.getDimension("overworld") });
          world.getDimension(`overworld`).runCommandAsync(`structure load beerus ${player.location.z} ${player.location.y} ${player.location.z}`)
          system.runTimeout(() => {
            player.runCommandAsync(`tp @s ~23 ~250 ~13`)
            },20)
          break;
    }
  });
}