///import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:enma") system.runTimeout(() => enma(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:enma") system.runTimeout(() => enma(evd.damagingEntity))
})

//enma
function enma(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:enma.name");
  form.body("ui.enma.description");
  form.button(" ");
  form.button("ui.enma.button.1");
  form.button("ui.enma.button_2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        birth(player);
        break;
      case 2:
        snakeway(player);
        break;
    }
  });
}

//enma #birth
function birth(player) {
  const form = new ActionFormData();
  form.title("ui.enma.title");
  form.body("ui.birth.description");
  form.button("");
  form.button("learn_birth");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        enma(player);
        break;
      case 1:
        player.teleport({ x: 0, y:  50, z: 12 }, { dimension: world.getDimension("overworld") });
        system.runTimeout(() => {
          player.runCommandAsync(`tp @s ~7 ~150 ~-11`)
          },20)
        break;
      }
    });
  }
  
//enma #snakeway
function snakeway(player) {
  const form = new ActionFormData();
  form.title("ui.enma.title");
  form.body("ui.snakeway.description");
  form.button("");
  form.button("learn_snakeway");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        enma(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 8000 &&
          !player.hasTag("dbe:has_snakeway")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 8000");
          player.runCommandAsync(
            'give @s dbe:vanity_2 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:snakeway.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_snakeway")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 8000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
