//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";


//kami_sama
world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:kami_sama") system.runTimeout(() => kami_sama(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:kami_sama") system.runTimeout(() => kami_sama(evd.damagingEntity))
})

//kami_sama
function kami_sama(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:kami_sama.name");
  form.body("ui.kami_sama.description");
  form.button(" ");
  form.button("ui.kami_sama.button_1");
  form.button("ui.kami_sama.button_2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        start_over(player);
        break;
        case 2:
          holywater(player);
          break;
    }
  });
}

//kami_sama #start_over
function start_over(player) {
  const form = new ActionFormData();
  form.title("ui.kami_sama.title");
  form.body("ui.start_over.description");
  form.button("");
  form.button("yes");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        kami_sama(player);
        break;
      case 1:
        player.runCommandAsync("function start");
        break;
    }
  });
}
//kami_sama #holywater
function holywater(player) {
  const form = new ActionFormData();
  form.title("ui.kami_sama.title");
  form.body("ui.holywater.description");
  form.button("");
  form.button("learn_holywater");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        kami_sama(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 5000 &&
          !player.hasTag("dbe:has_holywater")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 5000");
          player.runCommandAsync(
            'give @s dbe:holywater 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:holywater.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_holywater")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 5000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
