//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:king_kai") system.runTimeout(() => king_kai(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:king_kai") system.runTimeout(() => king_kai(evd.damagingEntity))
})

//king_kai
function king_kai(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:king_kai.name");
  form.body("ui.king_kai.description");
  form.button(" ");
  form.button("ui.king_kai.button.1");
  form.button("ui.king_kai.button_2");
  form.button("ui.king_kai.button_3");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        kaioken2(player);
        break;
      case 2:
        vanity2(player);
        break;
      case 3:
        potential(player);
        break;
    }
  });
}

//king_kai #kaioken2
function kaioken2(player) {
  const form = new ActionFormData();
  form.title("ui.king_kai.title");
  form.body("ui.kaioken2.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        king_kai(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 9000 &&
          !player.hasTag("dbe:has_kaioken")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 9000");
          player.addTag("dbe:kaioken_off");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "kaioken" },
            ],
          });
        } else if (player.hasTag("dbe:has_kaioken")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") <= 9000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
  
//king_kai #vanity2
function vanity2(player) {
  const form = new ActionFormData();
  form.title("ui.king_kai.title");
  form.body("ui.vanity2.description");
  form.button("");
  form.button("learn_vanity2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        king_kai(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 8000 &&
          !player.hasTag("dbe:has_vanity2")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 8000");
          player.runCommandAsync(
            'give @s dbe:vanity_2 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:vanity2.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_vanity2")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 8000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}

//king_kai #potential
function potential(player) {
  const form = new ActionFormData();
  form.title("ui.king_kai.title");
  form.body("ui.potential.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        king_kai(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 10000 &&
          !player.hasTag("dbe:has_potential")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 10000");
          player.addTag("dbe:potential_off");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "potential" },
            ],
          });
        } else if (player.hasTag("dbe:has_potential")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") <= 10000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}