//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:masterroshinpc") system.runTimeout(() => masterroshinpc(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:masterroshinpc") system.runTimeout(() => masterroshinpc(evd.damagingEntity))
})

//masterroshinpc
function masterroshinpc(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:masterroshinpc.name");
  form.body("ui.masterroshinpc.description");
  form.button(" ");
  form.button("ui.masterroshinpc.button.1");
  form.button("ui.masterroshinpc.button.2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        kisense(player);
        break;
        case 2:
          meditate(player);
          break;
      }
    });
  }
  
//masterroshinpc #kisense
function kisense(player) {
  const form = new ActionFormData();
  form.title("ui.masterroshinpc.title");
  form.body("ui.kisense.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        masterroshinpc(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 4000 &&
          !player.hasTag("dbe:has_kisense")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 4000");
          player.addTag("dbe:scouter");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "kisense" },
            ],
          });
        } else if (player.hasTag("dbe:has_kisense")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") <= 4000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
//masterroshinpc #meditate
function meditate(player) {
  const form = new ActionFormData();
  form.title("ui.masterroshinpc.title");
  form.body("ui.meditate.description");
  form.button("");
  form.button("learn_meditate");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        masterroshinpc(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 10000 &&
          !player.hasTag("dbe:has_meditate")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 10000");
          player.runCommandAsync(
            'give @s dbe:meditate 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:meditate.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_meditate")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 10000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}