//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

//piccolo
world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:piccolo") system.runTimeout(() => piccolo(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:piccolo") system.runTimeout(() => piccolo(evd.damagingEntity))
})
//piccolo
function piccolo(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:piccolo.name");
  form.body("ui.piccolo.description");
  form.button(" ");
  form.button("ui.piccolo.button_1");
  form.button("ui.piccolo.button_2");
  form.button("ui.piccolo.button_3");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        weight(player);
        break;
      case 2:
        kienzan(player);
        break;
      case 3:
        ki_blast(player);
        break;
    }
  });
}

//piccolo #weight
function weight(player) {
  const form = new ActionFormData();
  form.title("ui.piccolo.title");
  form.body("ui.piccolo_weight.description");
  form.button("");
  form.button("take_weight");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        piccolo(player);
        break;
      case 1:
        player.runCommandAsync("give @s dbe:piccolo_cape");
        break;
    }
  });
}

//piccolo #kienzan
function kienzan(player) {
  const form = new ActionFormData();
  form.title("ui.piccolo.title");
  form.body("ui.kienzan.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        piccolo(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 1750 &&
          !player.hasTag("dbe:has_kienzan")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 1750");
          player.runCommandAsync(
            'give @s dbe:kienzan 1 0 {"minecraft:keep_on_death":{}}'
          );
          player.addTag("dbe:has_kienzan");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.kienzan.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_not")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 1750) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}

//piccolo #ki blast
function ki_blast(player) {
  const form = new ActionFormData();
  form.title("ui.piccolo.title");
  form.body("ui.ki_blast.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        piccolo(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 1350 &&
          !player.hasTag("dbe:has_ki_blast")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 1350");
          player.runCommandAsync(
            'give @s dbe:ki_blast 1 0 {"minecraft:keep_on_death":{}}'
          );
          player.addTag("dbe:has_ki_blast");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.ki_blast.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_not")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 1350) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
