//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:trunksnpc") system.runTimeout(() => trunksnpc(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:trunksnpc") system.runTimeout(() => trunksnpc(evd.damagingEntity))
})

//trunksnpc
function trunksnpc(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:trunksnpc.name");
  form.body("ui.trunksnpc.description");
  form.button(" ");
  form.button("ui.trunksnpc.button.1");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        hopesword(player);
        break;
      }
    });
  }
  
//trunksnpc #hopesword
function hopesword(player) {
  const form = new ActionFormData();
  form.title("ui.trunksnpc.title");
  form.body("ui.hopesword.description");
  form.button("");
  form.button("learn_hopesword");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        trunksnpc(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 5000 &&
          !player.hasTag("dbe:has_hopesword")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 5000");
          player.runCommandAsync(
            'give @s dbe:hope_sword 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:hopesword.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_hopesword")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 5000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
