//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:vados") system.runTimeout(() => vados(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:vados") system.runTimeout(() => vados(evd.damagingEntity))
})

//vados
function vados(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:vados.name");
  form.body("ui.vados.description");
  form.button(" ");
  form.button("ui.vados.button.1");
  form.button("ui.vados.button_2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        angelic(player);
        break;
      case 2:
        vanity2(player);
        break;
      case 3:
        planet(player);
        break;        
    }
  });
}

//vados #angelic
function angelic(player) {
  const form = new ActionFormData();
  form.title("ui.vados.title");
  form.body("ui.angelic.description");
  form.button("");
  form.button("learn_angelic");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        vados(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 3000 &&
          !player.hasTag("dbe:has_angelic")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 3000");
          player.runCommandAsync(
            'give @s dbe:angelic_crystal 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:angelic.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_angelic")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 3000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
      }
    });
  }
  
//vados #vanity2
function vanity2(player) {
  const form = new ActionFormData();
  form.title("ui.vados.title");
  form.body("ui.vanity2.description");
  form.button("");
  form.button("learn_vanity2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        vados(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 8000 &&
          !player.hasTag("dbe:has_vanity2")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 8000");
          player.runCommandAsync(
            'give @s dbe:vanity_2 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:vanity2.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_vanity2")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 8000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
//vados #planet
function planet(player) {
  const form = new ActionFormData();
  form.title("ui.vados.title");
  form.body("ui.planet.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        vados(player);
        break;
        case 1:
          player.teleport({ x: 5000, y:  70, z: 5000 }, { dimension: world.getDimension("overworld") });
          world.getDimension(`overworld`).runCommandAsync(`structure load beerus ${player.location.z} ${player.location.y} ${player.location.z}`)
          system.runTimeout(() => {
            player.runCommandAsync(`tp @s ~23 ~216 ~13`)
            },20)
          break;
    }
  });
}