//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:vegetanpc") system.runTimeout(() => vegetanpc(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:vegetanpc") system.runTimeout(() => vegetanpc(evd.damagingEntity))
})

//vegetanpc
function vegetanpc(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:vegetanpc.name");
  form.body("ui.vegetanpc.description");
  form.button(" ");
  form.button("ui.vegetanpc.button.1");
  form.button("ui.vegetanpc.button.2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        galick(player);
        break;
      case 2:
        space(player);
        break;
      }
    });
  }
  
//vegetanpc #galick
function galick(player) {
  const form = new ActionFormData();
  form.title("ui.vegetanpc.title");
  form.body("ui.galick.description");
  form.button("");
  form.button("learn_galick");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        vegetanpc(player);
        break;
        case 1:
          player.teleport({ x: 10000, y:  50, z: 12000 }, { dimension: world.getDimension("the_end") });
          system.runTimeout(() => {
            player.runCommandAsync(`tp @s ~7 ~150 ~-11`)
            },20)
          break;
        }
      });
    }
//vegetanpc #space
function space(player) {
  const form = new ActionFormData();
  form.title("ui.vegetanpc.title");
  form.body("ui.space.description");
  form.button("");
  form.button("learn_space");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        vegetanpc(player);
        break;
        case 1:
          player.teleport({ x: -9940, y: 150, z: -11951 }, { dimension: world.getDimension("the_end") });
          system.runTimeout(() => {
            },20)
          break;
        }
      });
    }
