//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:whis") system.runTimeout(() => whis(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:whis") system.runTimeout(() => whis(evd.damagingEntity))
})

//whis
function whis(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:whis.name");
  form.body("ui.whis.description");
  form.button(" ");
  form.button("ui.whis.button.1");
  form.button("ui.whis.button_2");
  form.button("ui.whis.button_3");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        divine_ki(player);
        break;
      case 2:
        angelstaff(player);
        break;
      case 3:
        flight(player);
        break;
    }
  });
}

//whis #divine ki
function divine_ki(player) {
  const form = new ActionFormData();
  form.title("ui.whis.title");
  form.body("ui.divine_ki.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        whis(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 80000 &&
          !player.hasTag("dbe:has_divine_ki")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 80000");
          player.addTag("dbe:has_divine_ki");
          player.sendMessage({ rawtext: [{ translate: "learn.divine_ki" }] });
        } else if (player.hasTag("dbe:has_divine_ki")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.3" }] });
        } else if (getScore(player, "dbe:tp") < 80000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}

//whis #angelstaff
function angelstaff(player) {
  const form = new ActionFormData();
  form.title("ui.whis.title");
  form.body("ui.angelstaff.description");
  form.button("");
  form.button("learn_angelstaff");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        whis(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 5000 &&
          !player.hasTag("dbe:has_angelstaff")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 5000");
          player.runCommandAsync(
            'give @s dbe:angel_staff 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:angelstaff.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_angelstaff")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 5000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
//whis #flight
function flight(player) {
  const form = new ActionFormData();
  form.title("ui.whis.title");
  form.body("ui.flight.description");
  form.button("");
  form.button("learn");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        whis(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 5000 &&
          !player.hasTag("dbe:has_flight")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 5000");
          player.addTag("dbe:has_flight");
          player.sendMessage({ rawtext: [{ translate: "learn.flight" }] });
        } else if (player.hasTag("dbe:has_flight")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.3" }] });
        } else if (getScore(player, "dbe:tp") < 5000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}