//import
import { system, world } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
import { getScore } from "../../utils";

world.beforeEvents.playerInteractWithEntity.subscribe(evd => {
  if(evd.target.typeId === "dbe:zamasu") system.runTimeout(() => zamasu(evd.player) )
})

world.afterEvents.entityHitEntity.subscribe(evd => {
   if(evd.hitEntity.typeId === "dbe:zamasu") system.runTimeout(() => zamasu(evd.damagingEntity))
})
//zamasu
function zamasu(player) {
  const form = new ActionFormData();
  form.title("entity.dbe:zamasu.name");
  form.body("ui.zamasu.description");
  form.button(" ");
  form.button("ui.zamasu.button.1");
  form.button("ui.zamasu.button_2");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 1:
        demonic(player);
        break;
      case 2:
        arm(player);
        break;
    }
  });
}

//zamasu #demonic
function demonic(player) {
  const form = new ActionFormData();
  form.title("ui.zamasu.title");
  form.body("ui.demonic.description");
  form.button("");
  form.button("learn_demonic");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        zamasu(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 3000 &&
          !player.hasTag("dbe:has_demonic")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 3000");
          player.runCommandAsync(
            'give @s dbe:demonic_crystal 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:demonic.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_demonic")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 3000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
      }
    });
  }
  
//zamasu #arm
function arm(player) {
  const form = new ActionFormData();
  form.title("ui.zamasu.title");
  form.body("ui.arm.description");
  form.button("");
  form.button("learn_arm");
  form.show(player).then((response) => {
    switch (response.selection) {
      case 0:
        zamasu(player);
        break;
      case 1:
        if (
          getScore(player, "dbe:tp") >= 100000 &&
          !player.hasTag("dbe:has_arm")
        ) {
          player.runCommandAsync("scoreboard players remove @s dbe:tp 100000");
          player.runCommandAsync(
            'give @s dbe:arm 1 0'
          );
          player.addTag("dbe:has_not");
          player.sendMessage({
            rawtext: [
              { translate: "learn.learn" },
              { text: " " },
              { translate: "item.dbe:arm.name" },
            ],
          });
        } else if (player.hasTag("dbe:has_arm")) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.4" }] });
        } else if (getScore(player, "dbe:tp") < 100000) {
          player.sendMessage({ rawtext: [{ translate: "learn.error.1" }] });
        }
        break;
    }
  });
}
