import { world } from "@minecraft/server";

export function getScore(target, objective) {
  try {
    const oB = world.scoreboard.getObjective(objective);
    return oB.getScore(
      typeof target == "string"
        ? oB.getParticipants().find((pT) => pT.displayName == target)
        : target.scoreboardIdentity
    );
  } catch {
    return 0;
  }
}

export function formatNumber(value) {
  const ranges = [
    { divider: 1e9, suffix: "B" },
    { divider: 1e6, suffix: "M" },
    { divider: 1e3, suffix: "K" },
  ];
  for (const range of ranges)
    if (value >= range.divider)
      return ((value / range.divider).toFixed(1) + range.suffix).toString();
  return value;
}
